::ROOT <- getroottable();
if (!("ConstantNamingConvention" in ROOT))
{
    foreach (a,b in Constants)
        foreach (k,v in b)
            ROOT[k] <- v != null ? v : 0
}

::robot_boss_table <- [
    [ 0, 5, 3375, "MVM.GiantScoutLoop", "MVM.GiantEntranceScout", "MVM.GiantCommonExplodes"],
    [ 1, 5, 3375, "MVM.GiantScoutLoop", "MVM.GiantEntranceScout", "MVM.GiantCommonExplodes"],
    [ 2, 8, 4875, "MVM.GiantScoutLoop", "MVM.GiantEntranceSniper", "MVM.GiantCommonExplodes"],
    [ 3, 3, 4800, "MVM.GiantSoldierLoop", "MVM.GiantEntranceSoldier", "MVM.GiantSoldierExplodes"],
    [ 4, 4, 4825, "MVM.GiantDemomanLoop", "MVM.GiantEntranceDemoman", "MVM.GiantCommonExplodes"],
    [ 5, 8, 4850, "MVM.GiantScoutLoop", "MVM.GiantEntranceMedic", "MVM.GiantCommonExplodes"],
    [ 6, 2, 4700, "MVM.GiantHeavyLoop", "MVM.GiantEntranceHeavy", "MVM.GiantCommonExplodes"],
    [ 7, 6, 4825, "MVM.GiantPyroLoop", "MVM.GiantEntrancePyro", "MVM.GiantCommonExplodes"],
    [ 8, 8, 4875, "MVM.GiantScoutLoop", "MVM.GiantEntranceSpy", "MVM.GiantCommonExplodes"],
    [ 9, 8, 4850, "MVM.GiantScoutLoop", "MVM.GiantEntranceEngineer", "MVM.GiantCommonExplodes"]
]

::TF_CLASS_NAMES <- [
    "generic",
    "scout",
    "sniper",
    "soldier",
    "demoman",
    "medic",
    "heavy",
    "pyro",
    "spy",
    "engineer"
]

::players <- []

::red_players <- []

::MaxPlayers <- MaxClients().tointeger();
function MakePlayerBoss()
{
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(i)
        if (player == null)
        return
        players.push(player)
        foreach (GetBluePlayer in players)
        {
            if (GetBluePlayer.GetTeam() == 2)
            {
                red_players.push(GetBluePlayer)
            }
        }
        if ((player.HasItem() == true) && (NetProps.GetPropEntity(player, "m_hItem").GetClassname() == "item_teamflag") && (player.GetEFlags() != 1048576) )
        {
            for (local i = 0; i < 7; i++)
            {
                local weapon = NetProps.GetPropEntityArray(player, "m_hMyWeapons", i);
                if (weapon == null)
                    continue;
                    weapon.Destroy()
            }
            //printl(red_players.len())
            local index = player.GetPlayerClass()
            player.SetIsMiniBoss(true)
            //player.AddCustomAttribute("bombinomicon effect on death", 1, -1)
            //player.AddCondEx(56, 99999, -1)
            player.AddCondEx(273, 1, -1)
            //player.SetGravity(1.55)
            // Mark them as a giant so we don't do it again (clear this on death)
            player.AddCustomAttribute("cancel falling damage", 1, -1)
            player.AddCustomAttribute("crit kill will gib", 1.0, -1)
            player.AddCustomAttribute("ubercharge overheal rate penalty", 0, -1)
            player.AddCustomAttribute("reduced_healing_from_medics", 0.5, -1);
            player.AddCustomAttribute("patient overheal penalty", 0, -1);
            player.AddCustomAttribute("no_duck", 1, -1);
            player.AddEFlags(1048576)
            player.SetModelScale(1.75, 0.0)
            player.AddCustomAttribute("head scale", 0.7, -1)
            local maxHealth = CalculateBossHP();
            local previousmaxhp = player.GetMaxHealth()
            player.SetHealth(maxHealth);
            player.SetMaxHealth(maxHealth);
            player.RemoveCustomAttribute("max health additive bonus");
            player.AddCustomAttribute("max health additive bonus", maxHealth - previousmaxhp, -1);
            player.SetHealth(player.GetMaxHealth())
            local index = player.GetPlayerClass()
            //printl(maxHealth)
            foreach (loopsound in robot_boss_table)
            {
                if (index == loopsound[0])
                {
                    player.EmitSound(loopsound[3]) // Special thanks to Sprinkles for helping me set this up
                }
            }
            foreach (giantentrancevoice in robot_boss_table)
            {
                if (index == giantentrancevoice[0])
                {
                    EmitSoundEx({sound_name = giantentrancevoice[4], origin = player.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
                }
            }
            //printl("test4")
            switch(TF_CLASS_NAMES[player.GetPlayerClass()])
            {
                case "scout":
                {
                    player.AddCustomAttribute("no double jump", 1.0, -1)
                    player.AddCustomAttribute("damage force reduction", 0.7, -1)
                    player.AddCustomAttribute("airblast vulnerability multiplier", 0.5, -1)
                    printl("test3")
                    switch(RandomInt(1,2))
                    {
                        case 1:
                            //printl("test1")
                            player.GiveWeapon("GiantScoutForceANature")
                            player.AddCustomAttribute("move speed bonus", 0.7, -1)
                            break
                        case 2:
                            //printl("test2")
                            player.GiveWeapon("GiantScoutSandman")
                            player.AddCustomAttribute("move speed bonus", 0.8, -1)
                            break
                    }
                    break
                }
                case "sniper":
                {
                    player.AddCustomAttribute("damage force reduction", 0.70, -1)
                    player.AddCustomAttribute("airblast vulnerability multiplier", 0.5, -1)
                    switch(RandomInt(1,2))
                    {
                        case 1:
                            //printl("test1")
                            player.GiveWeapon("GiantSniperHuntsman")
                            player.AddCustomAttribute("move speed bonus", 0.60, -1)
                            break
                        case 2:
                            //printl("test2")
                            player.GiveWeapon("GiantSniperSMG")
                            player.AddCustomAttribute("move speed bonus", 0.70, -1)
                            break
                    }
                    break
                }
                case "soldier":
                {
                    player.AddCustomAttribute("damage force reduction", 0.5, -1)
                    player.AddCustomAttribute("airblast vulnerability multiplier", 0.35, -1)
                    switch(RandomInt(1,2))
                    {
                        case 1:
                            //printl("test1")
                            player.GiveWeapon("GiantSoldierRapidFire")
                            player.AddCustomAttribute("move speed bonus", 0.60, -1)
                            break
                        case 2:
                            //printl("test2")
                            player.GiveWeapon("GiantSoldierBison")
                            player.AddCustomAttribute("move speed bonus", 0.65, -1)
                            break
                    }
                        break
                    }
                    case "demoman":
                        {
                            player.AddCustomAttribute("damage force reduction", 0.55, -1)
                            player.AddCustomAttribute("airblast vulnerability multiplier", 0.40, -1)
                            switch(RandomInt(1,2))
                            {
                                case 1:
                                    //printl("test1")
                                    player.GiveWeapon("GiantDemomanRapidFire")
                                    player.AddCustomAttribute("move speed bonus", 0.62, -1)
                                    break
                                case 2:
                                    //printl("test2")
                                    player.GiveWeapon("GiantDemoknight")
                                    player.GiveWeapon(131)
                                    player.GiveWeapon(405)
                                    player.AddCustomAttribute("move speed bonus", 0.5, -1)
                                    break
                            }
                            break
                        }
                        case "medic":
                        {
                            player.AddCustomAttribute("move speed bonus", 0.7, -1)
                            player.AddCustomAttribute("damage force reduction", 0.75, -1)
                            player.AddCustomAttribute("airblast vulnerability multiplier", 0.55, -1)
                            switch(RandomInt(1,2))
                            {
                                case 1:
                                    //printl("test1")
                                    player.GiveWeapon("GiantMedicCrossbow")
                                    break
                                case 2:
                                    //printl("test2")
                                    player.GiveWeapon("GiantMedicOverdose")
                                    break
                            }
                            break
                        }
                        case "heavy":
                        {
                            player.AddCustomAttribute("damage force reduction", 0.4, -1)
                            player.AddCustomAttribute("airblast vulnerability multiplier", 0.2, -1)
                            switch(RandomInt(1,2))
                            {
                                case 1:
                                    player.GiveWeapon("GiantHeavyDeflector")
                                    //printl("test1")
                                    player.AddCustomAttribute("move speed bonus", 0.60, -1)
                                    break
                                case 2:
                                    player.GiveWeapon("GiantHeavyFistsOfSteel")
                                    //printl("test2")
                                    player.AddCustomAttribute("move speed bonus", 0.5, -1)
                                    break
                            }
                            break
                        }
                        case "pyro":
                    {
                        player.AddCustomAttribute("damage force reduction", 0.6, -1)
                        player.AddCustomAttribute("airblast vulnerability multiplier", 0.4, -1)
                        switch(RandomInt(1,2))
                        {
                            case 1:
                                //printl("test1")
                                player.GiveWeapon("GiantPyroFlamethrower")
                                player.AddCustomAttribute("move speed bonus", 0.5, -1)
                                break
                            case 2:
                                //printl("test2")
                                player.GiveWeapon("GiantPyroManmelter")
                                player.AddCustomAttribute("move speed bonus", 0.65, -1)
                                break
                        }
                        break
                    }
                    case "spy":
                    {
                        player.AddCustomAttribute("move speed bonus", 0.7, -1)
                        player.AddCustomAttribute("damage force reduction", 0.6, -1)
                        player.AddCustomAttribute("airblast vulnerability multiplier", 0.4, -1)
                        switch(1)
                        {
                            case 1:
                                //printl("test1")
                                player.GiveWeapon("GiantSpy")
                                break
                        }
                        break
                    }
                case "engineer":
                {
                    player.AddCustomAttribute("damage force reduction", 0.7, -1)
                    player.AddCustomAttribute("airblast vulnerability multiplier", 0.5, -1)
                    switch(RandomInt(1,2))
                    {
                        case 1:
                            //printl("test1")
                            player.GiveWeapon("GiantEngineerWidowmaker")
                            player.AddCustomAttribute("move speed bonus", 0.60, -1)
                            player.GiveWeapon(142)
                            player.GiveWeapon(25)
                            break
                        case 2:
                            //printl("test2")
                            player.GiveWeapon("GiantEngineerPomson")
                            player.AddCustomAttribute("move speed bonus", 0.65, -1)
                            player.GiveWeapon(142)
                            player.GiveWeapon(25)
                            break
                    }
                    break
                }
            }
        }
    }
}

function OnGameEvent_teamplay_flag_event(params)
{
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(i)
        if (player == null)
        continue;
        if (((player.HasItem() == true) && (NetProps.GetPropEntity(player, "m_hItem").GetClassname() == "item_teamflag")))
        {
            EntFireByHandle(self, "runscriptcode", "GiantRobotFootsteps(activator)", 0.1, player, player)
            player.SetIsMiniBoss(false)
        }
        if ((params.eventtype == 4) && (player.IsMiniBoss() == true))
        {
            player.TakeDamage(999999, 1048640, null)
        }
    }
}

function GiantRobotFootsteps(player)
{
    local player_class = player.GetPlayerClass()
    if ((player_class in robot_table) && (player.IsMiniBoss() == true))
    {
        local index = player.GetPlayerClass()
        foreach (giantfootsteps in robot_boss_table)
        {
            if (index == giantfootsteps[0])
            {
                activator.AddCustomAttribute("override footstep sound set", (giantfootsteps[1]), -1); // Special thanks to Sprinkles for helping me set this up
            }
        }
    }
}

::GiantDeath <- function(params)
{
    if (!("userid" in params))
    return;
    local player = GetPlayerFromUserID(params.userid)
    if (player.IsMiniBoss())
    {
        GiantReset(player)
        local bossBar = Entities.FindByClassname(null, "monster_resource");
        NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
    }
}

::GiantReset <- function(player)
{
    player.RemoveCustomAttribute("cancel falling damage")
    player.RemoveCustomAttribute("no double jump")
    player.RemoveCustomAttribute("crit kill will gib")
    player.RemoveCustomAttribute("attack projectiles")
    player.RemoveCustomAttribute("damage force reduction")
    player.RemoveCustomAttribute("airblast vulnerability multiplier")
    player.RemoveCustomAttribute("ubercharge overheal rate penalty")
    player.RemoveCustomAttribute("reduced_healing_from_medics")
    player.RemoveCustomAttribute("patient overheal penalty")
    player.RemoveCustomAttribute("no_duck")
    player.RemoveCustomAttribute("head scale")
    player.RemoveCondEx(21, true)
    player.RemoveCondEx(56, true)
    player.RemoveCondEx(273, true)
    //player.SetGravity(1.0)
    player.SetIsMiniBoss(false)
    local index = player.GetPlayerClass();
    foreach (loopsound in robot_boss_table)
    {
        if (index == loopsound[0])
        {
            StopSoundOn(loopsound[3], player) // Special thanks to Sprinkles for helping me set this up
        }
    }
    foreach (giantdeathsound in robot_boss_table)
    {
        if (index == giantdeathsound[0])
        {
            EmitSoundEx({sound_name = giantdeathsound[5], origin = player.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
        }
    }
}

::GiantStart <- function(params)
{
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(0)
        if (player != null)
        {
        if (player.IsMiniBoss())
            {
                GiantReset(player)
            }
        }
    }
}

::GiantTakeDamage <- function(params)
{
    if (!params.const_entity.IsPlayer()) return;
    if(params.const_entity.IsMiniBoss() && (params.damage_custom == 2))
    {
        params.crit_type = 0
        params.damage = params.const_entity.GetMaxHealth() * 1
    }
}

::GiantThink <- function()
{
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(i)
        if (player != null && player.IsMiniBoss())
        {
            TickBossBar(player)
        }
    }
    EntFireByHandle(self, "RunScriptCode", "GiantThink()", 0.05, null, null); // call self to make a fake think!
}

function PlayerHealed()
{
    if ((player.IsMiniBoss() == true) && player.GetPlayerClass() == TF_CLASS_MEDIC && (player.GetHealTarget() == TF_CLASS_SCOUT))
    {

    }
}

/*
function BossBuffs()
{
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(i)
        if (player == null)
        return
        if ((player.HasItem() == true) && (NetProps.GetPropEntity(player, "m_hItem").GetClassname() == "item_teamflag"))
        {
            //"tf_mvm_bot_flag_carrier_interval_to_1st_upgrade" = "5"
            Convars.Getint("tf_mvm_bot_flag_carrier_interval_to_1st_upgrade")
        }
    }
}
*/