::robot_model_cache <- {
    [TF_CLASS_SCOUT] = {model = "models/player/fracture/bot_scout.mdl", viewmodel = "models/weapons/c_models/c_scout_robot_arms.mdl"},
    [TF_CLASS_SOLDIER] = {model = "models/player/fracture/bot_soldier.mdl", viewmodel = "models/weapons/c_models/c_soldier_robot_arms.mdl"},
    [TF_CLASS_PYRO] = {model = "models/player/fracture/bot_pyro.mdl", viewmodel = "models/weapons/c_models/c_pyro_robot_arms.mdl"},
    [TF_CLASS_DEMOMAN] = {model = "models/player/fracture/bot_demoman.mdl", viewmodel = "models/weapons/c_models/c_demo_robot_arms.mdl"},
    [TF_CLASS_HEAVYWEAPONS] = {model = "models/player/fracture/bot_heavy.mdl", viewmodel = "models/weapons/c_models/c_heavy_robot_arms.mdl"},
    [TF_CLASS_ENGINEER] = {model = "models/player/fracture/bot_engineer.mdl", viewmodel = "models/weapons/c_models/c_engineer_robot_arms.mdl"},
    [TF_CLASS_MEDIC] = {model = "models/player/fracture/bot_medic.mdl", viewmodel = "models/weapons/c_models/c_medic_robot_arms.mdl"},
    [TF_CLASS_SNIPER] = {model = "models/player/fracture/bot_sniper.mdl", viewmodel = "models/weapons/c_models/c_sniper_robot_arms.mdl"},
    [TF_CLASS_SPY] = {model = "models/player/fracture/bot_spy.mdl", viewmodel = "models/weapons/c_models/c_spy_robot_arms.mdl"}
}

foreach (_, value in robot_model_cache)
{
    PrecacheModel(value.model)
    PrecacheModel(value.viewmodel)
}

::robot_spy_arms_cache <- [
    "models/weapons/v_models/v_pda_spy_robo.mdl"
    "models/weapons/v_models/v_ttg_watch_spy_robot.mdl"
    "models/weapons/v_models/v_watch_leather_spy_robot.mdl"
    "models/weapons/v_models/v_watch_pocket_spy_robot.mdl"
    "models/weapons/v_models/v_watch_spy_robot.mdl"
]

foreach (_, value in robot_spy_arms_cache)
{
    PrecacheModel(value)
}

::robot_table <- [
    [ 0, "scout"],
    [ 1, "scout"],
    [ 3, "soldier"],
    [ 7, "pyro"],
    [ 4, "demo"],
    [ 6, "heavy"],
    [ 9, "engineer"],
    [ 5, "medic"],
    [ 2, "sniper"],
    [ 8, "spy"]
]

::human_table <- [
    [ 0, "scout", 125 ],
    [ 1, "scout", 125 ],
    [ 3, "soldier", 200 ],
    [ 7, "pyro", 175 ],
    [ 4, "demo", 175 ],
    [ 6, "heavy", 300 ],
    [ 9, "engineer", 150 ],
    [ 5, "medic", 150 ],
    [ 2, "sniper", 125 ],
    [ 8, "spy", 125 ]
]

::ModelSpawn <- function(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    local player_class = player.GetPlayerClass()
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        if (player_class in robot_table)
        foreach (robotclass in robot_table)
        {
            local index = player.GetPlayerClass()
            if(index == robotclass[0])
            {
                player.SetCustomModelWithClassAnimations("models/player/fracture/bot_"+robotclass[1]+".mdl")
                local viewmodel = NetProps.GetPropEntity(player, "m_hViewModel")
                NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/weapons/c_models/c_"+robotclass[1]+"_robot_arms.mdl"))
            }
            for (local i = 0; i < 7; i++)
            {
                if(player.GetPlayerClass() == TF_CLASS_SPY)
                {
                    local weapon = NetProps.GetPropEntityArray(player, "m_hMyWeapons", i);
                    if (weapon != null)
                    {
                        if (weapon.GetClassname() == "tf_weapon_pda_spy")
                        {
                            NetProps.SetPropInt(weapon, "m_nModelIndex", GetModelIndex("models/weapons/v_models/v_pda_spy_robo.mdl"))
                            printl(weapon)
                        }
                        else if (weapon == "tf_weapon_invis")
                        {
                            NetProps.GetPropInt(weapon,"m_iViewModelIndex")
                        }
                    }
                }
            }
        }
    }
    if (player.GetTeam() == TF_TEAM_RED)
    {
        if (player_class in human_table)
        foreach (humanclass in human_table)
        {
            local index = player.GetPlayerClass()
            if(index == humanclass[0])
            {
                player.SetCustomModelWithClassAnimations("models/player/"+humanclass[1]+".mdl")
                local viewmodel = NetProps.GetPropEntity(player, "m_hViewModel")
                NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/weapons/c_models/c_"+humanclass[1]+"_arms.mdl"))
            }
        }
    }
}