::mainScript <- self

IncludeScript("Sprinkles_Util.nut")
IncludeScript("BombDeploy.nut")
IncludeScript("VoicelineRobot.nut")
IncludeScript("BossGiant.nut")
IncludeScript("TankMoney.nut")
IncludeScript("FootstepsSmall.nut")
IncludeScript("MainModels.nut")
IncludeScript("RedUpgrades.nut")
IncludeScript("PlayerDeath.nut")
IncludeScript("RobotHotHand.nut")
IncludeScript("RobotDeathSound.nut")
IncludeScript("RobotImpactSound.nut")
IncludeScript("RobotWeaponSounds.nut")
IncludeScript("RobotBlood.nut")
IncludeScript("TankHandler.nut")
//IncludeScript("StopThatTankTournament.nut")
IncludeScript("give_tf_weapon/master.nut")
IncludeScript("RedDestroyVoice.nut")


::ROOT <- getroottable();
if (!("ConstantNamingConvention" in ROOT))
{
    foreach (a,b in Constants)
        foreach (k,v in b)
            ROOT[k] <- v != null ? v : 0
}

ClearGameEventCallbacks()

function OnGameEvent_player_spawn(params)
{
    TankPlayerSpawn(params)
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    ModelSpawn(params)
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        EntFireByHandle(self, "runscriptcode", "SmallFootsteps(activator)", 0.1, player, player)
        RobotBloodHide(params)
        SlappyHide(params)
        player.Regenerate(true)
    }
    if (player.GetTeam() == TF_TEAM_RED)
    {
        HumanBloodShow(params)
        //EntFireByHandle(self, "runscriptcode", "RomeVision(activator)", 0.1, player, player)
    }
    RedUpgrades(params)
}

function OnScriptHook_OnTakeDamage(params)
{
    local player = params.const_entity
    if (player.GetTeam() == 3)
    {
        GiantTakeDamage(params)
        //RobotBloodDecal(params)
        PlayerImpact(params)
        RobotWeaponImpact(params)
    }
    /*local MaxDamageTypes = 30
    for (local i = 1; i <= MaxDamageTypes ; i++)
    {
        local damagetype = 1 << i
        if((params.damage_type & damagetype) == damagetype)
        {
            print(damagetype + ", ")
        }
    }
    */
}

function OnGameEvent_player_death(params)
{
    PlayerDeath(params)
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        PlayerDeathLineStandard(params)
    }
    local attacker = GetPlayerFromUserID(params.attacker)
    local dieer = GetPlayerFromUserID(params.userid)
    if(dieer.IsMiniBoss())
    {
        GiantDeath(params)
    }
    if(player.IsMiniBoss)
    {
        local bossBar = Entities.FindByClassname(null, "monster_resource");
        NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
    }
    GiantDeath(params)
    //&& attacker.GetTeam() == TF_TEAM_RED
}

function TeamNames()
{
    Convars.SetValue("mp_tournament_redteamname", "MANN CO.")
    Convars.SetValue("mp_tournament_blueteamname", "GRAY GRAVEL CO.")
}

function OnPostSpawn()
{
    EntFireByHandle(self, "RunScriptCode", "TeamNames()", 0.1, null, null)
    EntFireByHandle(m_ifunc_capturezone, "Disable", "", 0.1, null, null); // disable the capturezone we should only enable once the animation is complete
	CaptureZoneThink() //make a fake think so we don't override the main one!
    BombDeployPostSpawn()
    TankPostSpawn()
    GiantThink()
    SlappyThink()
    //SpyDisguiseRed()
}

function OnGameEvent_post_inventory_application(params)
{
    InventoryApplicationMaster(params)
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        SlappyHide(params)
    }
}

function OnGameEvent_teamplay_round_start(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        GiantStart(params)
    }
    local cosmetic = null
	while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
	{
		cosmetic.SetDrawEnabled(true)
	}
}

function OnGameEvent_teamplay_round_win(params)
{
    for (local i = 1; i <= MaxPlayers; i++ )
    {
        local player = PlayerInstanceFromIndex(i)
        if (player == null)
        continue;
        if (player.IsMiniBoss())
        {
            GiantReset(player)
        }
    }
    local cosmetic = null
	while (cosmetic = Entities.FindByClassname(cosmetic, "tf_wearable")) // Goes over every cosmetic item, executing code below
	{
		cosmetic.SetDrawEnabled(true)
	}
}

__CollectGameEventCallbacks(this)