//// Util File Full of very useful things!

::DEPLOYTIME_SMALL 				<- 2.25;
::DEPLOYTIME_BIG 				<- 2.6;
::DEPLOYTIME_GENERIC 			<- 2.0;

::TF_PLAYERCLASS_GENERIC 		<- 0;
::TF_PLAYERCLASS_SCOUT 			<- 1;
::TF_PLAYERCLASS_SNIPER 		<- 2;
::TF_PLAYERCLASS_SOLDIER 		<- 3;
::TF_PLAYERCLASS_DEMOMAN 		<- 4;
::TF_PLAYERCLASS_MEDIC 			<- 5;
::TF_PLAYERCLASS_HEAVY 			<- 6;
::TF_PLAYERCLASS_PYRO 			<- 7;
::TF_PLAYERCLASS_SPY 			<- 8;
::TF_PLAYERCLASS_ENGINEER 		<- 9;
::TF_PLAYERCLASS_CIVILIAN		<- 10;

::TF_TEAM_ANY 					<- 0;
::TF_TEAM_SPECTATOR 			<- 1;
::TF_TEAM_RED					<- 2;
::TF_TEAM_BLUE 					<- 3;
::TF_TEAM_BOSS 					<- 5;

::DMG_GENERIC 					<- 1 << 0
::DMG_CRUSH 					<- 1 << 1
::DMG_BULLET 					<- 1 << 2
::DMG_SLASH 					<- 1 << 3
::DMG_BURN 						<- 1 << 4
::DMG_TRAIN 					<- 1 << 5
::DMG_FALL	 					<- 1 << 6
::DMG_BLAST 					<- 1 << 7
::DMG_CLUB	 					<- 1 << 8
::DMG_SHOCK 					<- 1 << 9
::DMG_SONIC 					<- 1 << 10
::DMG_ENERGYBEAM 				<- 1 << 11
::DMG_PREVENT_PHYSICS_FORCE  	<- 1 << 12
::DMG_NEVERGIB  				<- 1 << 13
::DMG_ALWAYSGIB  				<- 1 << 14
::DMG_DROWN 					<- 1 << 15
::DMG_PARALYZE 					<- 1 << 16
::DMG_SAWBLADE 					<- 1 << 17
::DMG_POISON 					<- 1 << 18
::DMG_RADIATION 				<- 1 << 19
::DMG_DROWNRECOVER 				<- 1 << 20
::DMG_CRITICAL 					<- 1 << 21
::DMG_MELEE  					<- 1 << 22
::DMG_REMOVENORAGDOLL  			<- 1 << 23
::DMG_PHYSGUN  					<- 1 << 24
::DMG_PLASMA  					<- 1 << 25
::DMG_AIRBOAT  					<- 1 << 26
::DMG_DISSOLVE  				<- 1 << 27
::DMG_BLAST_SURFACE  			<- 1 << 28
::DMG_BUCKSHOT  				<- 1 << 29
::DMG_HEADSHOT   				<- 1 << 30
::DMG_LASTGENERICFLAG    		<- 1 << 31

::TF_CLASS_NAMES <- [
    "generic",
    "scout",
    "sniper",
    "soldier",
    "demo",
    "medic",
    "heavy",
    "pyro",
    "spy",
    "engineer",
    "civilian"
];

::MaxPlayers <- MaxClients().tointeger();

::tf_player_manager <- Entities.FindByClassname(null, "tf_player_manager");

::tf_gamerules <- Entities.FindByClassname(null, "tf_gamerules");

::GetPlayerUserID <- function(player)
{
    return NetProps.GetPropIntArray(tf_player_manager, "m_iUserID", player.entindex());
}

::SetEntityColor <- function(entity, r, g, b, a)
{
    local color = (r) | (g << 8) | (b << 16) | (a << 24);
    NetProps.SetPropInt(entity, "m_clrRender", color);
}

::GetEntityColor <- function(entity)
{
    local color = NetProps.GetPropInt(entity, "m_clrRender");
    local clr = {}
    clr.r <- color & 0xFF;
    clr.g <- (color >> 8) & 0xFF;
    clr.b <- (color >> 16) & 0xFF;
    clr.a <- (color >> 24) & 0xFF;
    return clr;
}

::GetPlayerName <- function(player)
{
    return NetProps.GetPropString(player, "m_szNetname");
}

::GetPlayerSteamID <- function(player)
{
    return NetProps.GetPropString(player, "m_szNetworkIDString");
}

::GetPlayerClassString <- function( player )
{
	local playerclass = ""
	switch(player.GetPlayerClass())
	{
		case 0:
			playerclass = "generic"
			break;
		case 1:
			playerclass = "scout"
			break;
		case 2:
			playerclass = "sniper"
			break;
		case 3:
			playerclass = "soldier"
			break;
		case 4:
			playerclass = "demo"
			break;
		case 5:
			playerclass = "medic"
			break;
		case 6:
			playerclass = "heavy"
			break;
		case 7:
			playerclass = "pyro"
			break;
		case 8:
			playerclass = "spy"
			break;
		case 9:
			playerclass = "engineer"
			break;
		case 10:
			playerclass = "civilian"
			break;
		default:
			playerclass = "null"
	}
	return playerclass
}

::AngleBetween <- function(v1,v2)
{
	local move_dir = (v2 - v1);


	return move_dir;
}

::VectorAngles <- function(v1,v2)
{
	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0)
			yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0)
			pitch += 360.0;
	}

	return QAngle(0.0, yaw, 0.0);
}

::PlayerDisable <- function(ply,toggle = false)
{
	if(toggle)
	{
		ply.AddCustomAttribute("no_attack", 1, -1);
		ply.AddCustomAttribute("no_duck", 1, -1);
		ply.AddCustomAttribute("no_jump", 1, -1);
		ply.SetMoveType(0,0)
	}
	else
	{
    	ply.AddCustomAttribute("no_attack", 0, -1);
		if(!ply.IsMiniBoss()){ply.AddCustomAttribute("no_duck", 0, -1);}
		ply.AddCustomAttribute("no_jump", 0, -1);
		ply.SetMoveType(2,0)
	}
}

::PlayDeployAnim <- function(ply)
{
    ply.SetSequence(ply.LookupSequence("primary_deploybomb"));
}

::SetAttributeDelayed <- function(player ,attribute, attributenum = 0 || [], delay = 0.0, checkclass = false, checkboss = false, bossattributenum = 0 || []  )
{
    EntFireByHandle(mainScript, "RunScriptCode", AttributeSetter(player , attribute, attributenum, checkclass, checkboss, bossattributenum), delay, null, null); // call self to make a fake think!
}

function AttributeSetter(player , attribute, attributenum, checkclass, checkboss, bossattributenum)
{
    if(!checkclass)
	{
		player.AddCustomAttribute(attribute, attributenum, -1);
	}
	else
	{
		if(player.IsMiniBoss()){player.AddCustomAttribute(attribute, bossattributenum, -1);}
		else{player.AddCustomAttribute(attribute, attributenum, -1);}
	}
}