//-----------------------------------------------------------------------------
//Purpose: Creates and bonemerges a player class model. Meant for players changing animations while using weapons unintended for the class.
// Accepts only player's handle.
// (as far as 5.4.0 this is only used in AddThinkToViewModel() under "GiveWeapon().nut" )
//-----------------------------------------------------------------------------

::GTFW.CreateTFClassModel <- function(player)
{
	if ( !player.IsPlayer() ) {
		return GTFW.DevPrint(1,"CreateTFClassModel", "Function failed. Parameter is needs player handle.");
	}

	player.ValidateScriptScope()
	local player_scope = player.GetScriptScope();

	if ( "GTFW_playermodel" in player_scope ) {
		local playermodel = player_scope["GTFW_playermodel"];
		if ( playermodel && playermodel.IsValid() ) {
			playermodel.Kill()
		}
		delete player_scope["GTFW_playermodel"];
	}
	local playermodel = ""
	if (player.GetTeam() == TF_TEAM_RED)
	{
		playermodel = player.CreateCustomWearable("tf_wearable", GTFW_MODEL_TFCLASSES[player.GetPlayerClass()], null, player);
	}
	else
	{
		playermodel = player.CreateCustomWearable("tf_wearable", GTFW_MODEL_ROBOT_TFCLASSES[player.GetPlayerClass()], null, player);
	}
	playermodel.DisableDraw();

	GTFW.DevPrint(0,"CreateTFClassModel", "Created player model " + playermodel);

	player_scope["GTFW_playermodel"] <- playermodel;

	return playermodel;
}